<template>
  <div>
    <div v-if="document">
      <div ref="input" class="-hidden"><slot /></div>

      <rui-loading v-if="loading" />
      <rui-alert v-else-if="content === ''" variant="warning">No content to display</rui-alert>

      <div :class="componentCSS">
        <!-- eslint-disable vue/no-v-html -->
        <div v-if="htmlToc">
          <div class="doc-markdown__toc">
            <h2>Table of content</h2>
            <nav class="doc-markdown__toc__content" v-html="htmlToc" />
          </div>
        </div>
        <div v-if="content" class="doc-markdown__content" v-html="renderedMarkup" />
        <!-- eslint-enable vue/no-v-html -->
      </div>
    </div>
    <!-- eslint-disable vue/no-v-html -->
    <div v-else v-html="renderedMarkup" />
    <!-- eslint-enable vue/no-v-html -->
  </div>
</template>

<script>
import MarkdownIt from 'markdown-it'
import MarkdownItAnchor from 'markdown-it-anchor'
import MarkdownItTocDoneRight from 'markdown-it-toc-done-right'

import highlight from 'highlight.js'
import hSh from 'highlight.js/lib/languages/shell.js'
import hJs from 'highlight.js/lib/languages/javascript.js'
import hXml from 'highlight.js/lib/languages/xml.js'
import hScss from 'highlight.js/lib/languages/scss.js'

highlight.registerLanguage('shell', hSh)
highlight.registerLanguage('javascript', hJs)
highlight.registerLanguage('xml', hXml)
highlight.registerLanguage('scss', hScss)

const md = MarkdownIt({
  linkify: true,
  html: true,
  highlight: function (str, lang) {
    if (lang && highlight.getLanguage(lang)) {
      try {
        return highlight.highlight(str, { language: lang }).value
      } catch (__) {}
    }

    return ''
  },
})
md.use(MarkdownItAnchor, { permalink: true, permalinkBefore: true, permalinkSymbol: '§', permalinkClass: '-doc-permalink' })
  .use(MarkdownItTocDoneRight, {
    containerClass: 'doc-markdown__toc',
    listClass: '-unstyled',
  })

export default {
  name: 'MarkdownRenderer',
  props: {
    /**
     * File to load, without extension, directly under src/markdown
     *
     * Due to how Vite handles imports, it is not possible to easily throw random paths and expect it to work.
     * Keep the documents right under the "markdown" directory and it will be fine.
     */
    file: { required: false, type: String, default: null },
    /** Raw markdown. Don't use it with "file" */
    raw: { required: false, type: String, default: null },
    /** Whether to structure HTML for a large document */
    document: { required: false, type: Boolean, default: false },
  },
  data () {
    return {
      loading: false,
      content: null,
      renderedSlot: null,
      htmlToc: null,
    }
  },
  computed: {
    renderedMarkup () { return this.render(this.content) },
    componentCSS () {
      if (!this.document) return null

      return [
        'doc-markdown',
        this.htmlToc && 'doc-markdown--toc',
      ]
    },
  },
  methods: {
    render (string) {
      const html = md.render(string).trim()

      if (!this.document) return html

      const template = document.createElement('template')
      template.innerHTML = html
      const toc = template.content.querySelector('.doc-markdown__toc')
      if (toc) {
        template.content.removeChild(toc)
        this.htmlToc = toc.innerHTML
      }

      return template.innerHTML
    },
  },
  created () {
    if (this.raw) {
      this.content = this.raw
      return
    }

    if (!this.file) {
      this.$nextTick(() => { this.content = this.$refs.input.innerText })
      return
    }

    this.loading = true
    import(`../markdown/${this.file}.md?raw`)
      .then((r) => { this.content = r.default })
      .then(() => { this.loading = false })
  },
}
</script>
